/* How to create GSS data at the market-cohort level */

* set your directory * 
cd ""
use GSS_72_2014.dta, clear
keep if fefam!=.
keep if age>29
keep if race<3 

gen tradition = fefam<3 if !mi(fefam)
keep if tradition!=.
gen cohort_bin=.
forval i=0/5{
replace cohort_bin=1+`i' if cohort>`=1919+`i'*10' & cohort<`=1930+`i'*10' 
}
keep if cohort_bin!=. 

gen bac=degree>2 if !mi(degree)
keep if bac!=.

gen region_big=1 if region<3
replace region_big=2 if region>2&region<5
replace region_big=3 if region>4&region<8
replace region_big=4 if region>7

tostring race region_big bac sex cohort_bin, force replace
gen rce_rgnbig_deg_sx_chrt=race + region_big + bac + sex + cohort_bin
destring race region_big bac sex cohort_bin rce_rgnbig_deg_sx_chrt, force replace

collapse race region_big bac sex cohort_bin tradition (count) count=tradition , by(rce_rgnbig_deg_sx_chrt)

**create count and tradition values for opposite sex**
tostring race region_big bac cohort_bin, force replace
gen rce_rgnbig_deg_chrt=race + region_big + bac + cohort_bin
destring race region_big bac cohort_bin rce_rgnbig_deg_chr, force replace

gen tradition_M=tradition if sex==1
gen tradition_F=tradition if sex==2
gen count_M=count if sex==1
gen count_F=count if sex==2
bysort rce_rgnbig_deg_chrt: egen TRAD_GRP_M=max(tradition_M)
bysort rce_rgnbig_deg_chrt: egen TRAD_GRP_F=max(tradition_F)
bysort rce_rgnbig_deg_chrt: egen count_TRD_M=max(count_M)
bysort rce_rgnbig_deg_chrt: egen count_TRD_F=max(count_F)
drop count_F count_M tradition_F tradition_M

save GSS_marketdata.dta, replace
